<?php
/*
Plugin Name: Display Future Posts
Author URI: http://blog.brandt-net.de
Plugin URI: http://wordpress.org/extend/plugins/display-future-posts/
Description: Small Plugin to display future posts as a list. You can use the sidebar widget or you call the method display_future_posts() to display the future posts where ever you want. 
Version: 0.1.4
Author: Stefan Brandt
Min WP Version: 2.1.*
Max WP Version: 2.6.x

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS
OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

require_once(dirname(__FILE__).'/includes/const.php');

///////////////////////////////////////////////////////////////////////////////
// Display Future Posts - Stefan Brandt 22.12.2007
///////////////////////////////////////////////////////////////////////////////
function display_future_posts(){
	global $wpdb;
	$fb_date_today = current_time('mysql'); //today date GMT
  	if ( $scheduled = $wpdb->get_results("SELECT ID, post_title, post_date_gmt FROM $wpdb->posts WHERE post_status = 'future' AND post_date_gmt > '$fb_date_today' ORDER BY post_date ASC") ) 
	{
	  	$isDisplayTitle = get_option('display_future_posts_displaytitle');	
	  	$title = get_option('display_future_posts_title');
    	echo '<div class="display_future_posts">';
			if ($isDisplayTitle=="1" && $title!="")
		  	{
		     	 echo '<h2>' . $title . '</h2>';
		  	}
			
		    echo '<ul>';
		    foreach ($scheduled as $post) {
		      if ($post->post_title == '')
		  			 $post->post_title = sprintf(__('Post #%s'), $post->ID);
		      echo '<li>' . sprintf(__('%1$s in %2$s'), $post->post_title, human_time_diff( current_time('timestamp', 1), strtotime($post->post_date_gmt. ' GMT') ))  . '</li>';
			} //end for loop
		    echo '</ul>';
	    echo '</div>';
	} //end if
} //end [display_future_posts]

//initial the plugin
function display_future_posts_init() {
	if ( !function_exists('register_sidebar_widget') )
		return;

	// Register widget for use
	register_sidebar_widget(array('Future Posts', 'widgets'), 'display_future_posts');
}

// Run code and init
function display_future_posts_options() {
	if($_POST['display_future_posts_save']){
		$displaytitle = $_POST['display_future_posts_displaytitle'];
		
		update_option('display_future_posts_displaytitle', $displaytitle);
		update_option('display_future_posts_title', $_POST['display_future_posts_title']);
		
		echo '<div class="updated"><p>';
		_e('Settings are saved successfully!', DispFuturePosts_DOMAIN);
		echo '</p></div>';
	}
?>

<!-- -------------------------------- -->
<!-- start plugin admin settings page --> 
<!-- -------------------------------- -->
<div class="wrap">
	<h2>Display Future Posts</h2>
	<p><?php _e('This small plugin display future posts as a list. You can use the sidebar widget or you call the method display_future_posts() to display the future posts where ever you want.', DispFuturePosts_DOMAIN) ?></p>
	<h3><?php _e('General Settings', DispFuturePosts_DOMAIN) ?></h3>
	
	<form method="post" id="dfp_future_posts_options">
		<table summary="submit" class="form-table">
			<tr valign="top">
			  <th scope="row" valign="top"><?php _e('Title :', DispFuturePosts_DOMAIN); ?></th>
			  
			 	<td>
 		  	 		<label for="display_future_posts_displaytitle"><?php _e('Display Title? :', DispFuturePosts_DOMAIN); ?></label>
 				  	<input id="display_future_posts_displaytitle" name="display_future_posts_displaytitle" type="checkbox" value="<?php $displaytitle=get_option('display_future_posts_displaytitle'); if($displaytitle=="" || $displaytitle==0){ echo "1";} if($displaytitle=="1") { echo $displaytitle;}?>" size="1" maxlength="1" <? if ($displaytitle=="1"){echo "checked";}?>/>
					<br />
 	  	 		    <label for="display_future_posts_title"><?php _e('Title:', DispFuturePosts_DOMAIN); ?></label>
					<input name="display_future_posts_title" type="text" id="display_future_posts_title" value="<?php echo get_option('display_future_posts_title') ;?>" size="50" maxlength="50" />
					<br/><?php _e('Just enter the title you want for the display section.', DispFuturePosts_DOMAIN) ?>
			 	</td>
			</tr>
		</table>
		
		<p class="submit">
          <input class="button" type="submit" name="display_future_posts_save" value="<?php _e('Save Changes', DispFuturePosts_DOMAIN); ?> &raquo;" />
        </p>

	</form>
</div>
<!-- finished plugin settings page --> 

<?php
}

/* Init Admin Menu */
function display_future_posts_adminmenu(){
	add_options_page('Display Future Posts Options', 'Display Future Posts', 9, 'display-future-posts.php', 'display_future_posts_options');
}


/* ---------------------------------------------------------------------------- */
/* start main */
/* ---------------------------------------------------------------------------- */
{
	//change loeading files for WP version 2.6
	if (function_exists('load_plugin_textdomain')) {
		if ( !defined('WP_PLUGIN_DIR') ) {
			load_plugin_textdomain('display-future-posts', DispFuturePosts_DIR.'/languages');
		} else {
			load_plugin_textdomain('display-future-posts', false, DispFuturePosts_DIR.'/languages');
		}
	}
		
	add_action('admin_menu','display_future_posts_adminmenu', 1);
	add_action('widgets_init', 'display_future_posts_init');
		
} // end main


?>